Module javafx.graphics
Package javafx.scene.shape

# Class ArcTo

java.lang.Object
javafx.scene.shape.PathElement
javafx.scene.shape.ArcTo

public class ArcTo extends PathElement
A path element that forms an arc from the previous coordinates to the specified x and y coordinates using the specified radius.

For more information on path elements see the `Path` and `PathElement` classes.

Example:

    import javafx.scene.shape.*;

    Path path = new Path();

    MoveTo moveTo = new MoveTo();
    moveTo.setX(0.0);
    moveTo.setY(0.0);

    ArcTo arcTo = new ArcTo();
    arcTo.setX(50.0);
    arcTo.setY(50.0);
    arcTo.setRadiusX(50.0);
    arcTo.setRadiusY(50.0);

    path.getElements().add(moveTo);
    path.getElements().add(arcTo);

Following image demonstrates `radiusX`, `radiusY` and `xAxisRotation` parameters: `radiusX` is the horizontal radius of the full ellipse of which this arc is a partial section, `radiusY` is its vertical radius. `xAxisRotation` defines the rotation of the ellipse in degrees.

In most cases, there are four options of how to draw an arc from starting point to given end coordinates. They can be distinguished by `largeArcFlag` and `sweepFlag` parameters. `largeArcFlag == true` means that the arc greater than 180 degrees will be drawn. `sweepFlag == true` means that the arc will be drawn in the positive angle direction - i.e. the angle in the ellipse formula will increase from `[fromX, fromY]` to `[x,y]`. Following images demonstrate this behavior:

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final BooleanProperty`
  `largeArcFlag`
  The large arc flag.
  `final DoubleProperty`
  `radiusX`
  The horizontal radius to use for the arc.
  `final DoubleProperty`
  `radiusY`
  The vertical radius to use for the arc.
  `final BooleanProperty`
  `sweepFlag`
  The sweep flag
  `final DoubleProperty`
  `XAxisRotation`
  The x-axis rotation in degrees.
  `final DoubleProperty`
  `x`
  The x coordinate to arc to.
  `final DoubleProperty`
  `y`
  The y coordinate to arc to.

  ### Properties declared in class javafx.scene.shape.PathElement

  `absolute`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ArcTo()`
  Creates an empty instance of ArcTo.
  `ArcTo(double radiusX, double radiusY, double xAxisRotation, double x, double y, boolean largeArcFlag, boolean sweepFlag)`
  Creates a new instance of ArcTo.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final double`
  `getRadiusX()`
  Gets the value of the property radiusX.
  `final double`
  `getRadiusY()`
  Gets the value of the property radiusY.
  `final double`
  `getX()`
  Gets the value of the property x.
  `final double`
  `getXAxisRotation()`
  Gets the x-axis rotation in degrees.
  `final double`
  `getY()`
  Gets the value of the property y.
  `final boolean`
  `isLargeArcFlag()`
  Gets the value of the property largeArcFlag.
  `final boolean`
  `isSweepFlag()`
  Gets the value of the property sweepFlag.
  `final BooleanProperty`
  `largeArcFlagProperty()`
  The large arc flag.
  `final DoubleProperty`
  `radiusXProperty()`
  The horizontal radius to use for the arc.
  `final DoubleProperty`
  `radiusYProperty()`
  The vertical radius to use for the arc.
  `final void`
  `setLargeArcFlag(boolean value)`
  Sets the value of the property largeArcFlag.
  `final void`
  `setRadiusX(double value)`
  Sets the value of the property radiusX.
  `final void`
  `setRadiusY(double value)`
  Sets the value of the property radiusY.
  `final void`
  `setSweepFlag(boolean value)`
  Sets the value of the property sweepFlag.
  `final void`
  `setX(double value)`
  Sets the value of the property x.
  `final void`
  `setXAxisRotation(double value)`
  Sets the x-axis rotation in degrees.
  `final void`
  `setY(double value)`
  Sets the value of the property y.
  `final BooleanProperty`
  `sweepFlagProperty()`
  The sweep flag
  `String`
  `toString()`
  Returns a string representation of this `ArcTo` object.
  `final DoubleProperty`
  `XAxisRotationProperty()`
  The x-axis rotation in degrees.
  `final DoubleProperty`
  `xProperty()`
  The x coordinate to arc to.
  `final DoubleProperty`
  `yProperty()`
  The y coordinate to arc to.

  ### Methods declared in class javafx.scene.shape.PathElement

  `absoluteProperty, isAbsolute, setAbsolute`

  ### Methods declared in class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Property Details

  - ### radiusX

    public final DoubleProperty radiusXProperty
    The horizontal radius to use for the arc.
    Default value:
      0.0
    See Also:
      - `getRadiusX()`
      - `setRadiusX(double)`

  - ### radiusY

    public final DoubleProperty radiusYProperty
    The vertical radius to use for the arc.
    Default value:
      0.0
    See Also:
      - `getRadiusY()`
      - `setRadiusY(double)`

  - ### XAxisRotation

    public final DoubleProperty XAxisRotationProperty
    The x-axis rotation in degrees.
    See Also:
      - `getXAxisRotation()`
      - `setXAxisRotation(double)`

  - ### largeArcFlag

    public final BooleanProperty largeArcFlagProperty
    The large arc flag.
    Default value:
      false
    See Also:
      - `isLargeArcFlag()`
      - `setLargeArcFlag(boolean)`

  - ### sweepFlag

    public final BooleanProperty sweepFlagProperty
    The sweep flag
    Default value:
      false
    See Also:
      - `isSweepFlag()`
      - `setSweepFlag(boolean)`

  - ### x

    public final DoubleProperty xProperty
    The x coordinate to arc to.
    Default value:
      0.0
    See Also:
      - `getX()`
      - `setX(double)`

  - ### y

    public final DoubleProperty yProperty
    The y coordinate to arc to.
    Default value:
      0.0
    See Also:
      - `getY()`
      - `setY(double)`

- ## Constructor Details

  - ### ArcTo

    public ArcTo()
    Creates an empty instance of ArcTo.

  - ### ArcTo

    public ArcTo(double radiusX, double radiusY, double xAxisRotation, double x, double y, boolean largeArcFlag, boolean sweepFlag)
    Creates a new instance of ArcTo.
    Parameters:
      `radiusX` - horizontal radius of the arc
      `radiusY` - vertical radius of the arc
      `xAxisRotation` - the x-axis rotation in degrees
      `x` - horizontal position of the arc end point
      `y` - vertical position of the arc end point
      `largeArcFlag` - large arg flag: determines which arc to use (large/small)
      `sweepFlag` - sweep flag: determines which arc to use (direction)

- ## Method Details

  - ### setRadiusX

    public final void setRadiusX(double value)
    Sets the value of the property radiusX.
    Property description:
      The horizontal radius to use for the arc.
    Default value:
      0.0

  - ### getRadiusX

    public final double getRadiusX()
    Gets the value of the property radiusX.
    Property description:
      The horizontal radius to use for the arc.
    Default value:
      0.0

  - ### radiusXProperty

    public final DoubleProperty radiusXProperty()
    The horizontal radius to use for the arc.
    Default value:
      0.0
    See Also:
      - `getRadiusX()`
      - `setRadiusX(double)`

  - ### setRadiusY

    public final void setRadiusY(double value)
    Sets the value of the property radiusY.
    Property description:
      The vertical radius to use for the arc.
    Default value:
      0.0

  - ### getRadiusY

    public final double getRadiusY()
    Gets the value of the property radiusY.
    Property description:
      The vertical radius to use for the arc.
    Default value:
      0.0

  - ### radiusYProperty

    public final DoubleProperty radiusYProperty()
    The vertical radius to use for the arc.
    Default value:
      0.0
    See Also:
      - `getRadiusY()`
      - `setRadiusY(double)`

  - ### setXAxisRotation

    public final void setXAxisRotation(double value)
    Sets the x-axis rotation in degrees.
    Parameters:
      `value` - the x-axis rotation in degrees.

  - ### getXAxisRotation

    public final double getXAxisRotation()
    Gets the x-axis rotation in degrees.
    Returns:
      the x-axis rotation in degrees.

  - ### XAxisRotationProperty

    public final DoubleProperty XAxisRotationProperty()
    The x-axis rotation in degrees.
    See Also:
      - `getXAxisRotation()`
      - `setXAxisRotation(double)`

  - ### setLargeArcFlag

    public final void setLargeArcFlag(boolean value)
    Sets the value of the property largeArcFlag.
    Property description:
      The large arc flag.
    Default value:
      false

  - ### isLargeArcFlag

    public final boolean isLargeArcFlag()
    Gets the value of the property largeArcFlag.
    Property description:
      The large arc flag.
    Default value:
      false

  - ### largeArcFlagProperty

    public final BooleanProperty largeArcFlagProperty()
    The large arc flag.
    Default value:
      false
    See Also:
      - `isLargeArcFlag()`
      - `setLargeArcFlag(boolean)`

  - ### setSweepFlag

    public final void setSweepFlag(boolean value)
    Sets the value of the property sweepFlag.
    Property description:
      The sweep flag
    Default value:
      false

  - ### isSweepFlag

    public final boolean isSweepFlag()
    Gets the value of the property sweepFlag.
    Property description:
      The sweep flag
    Default value:
      false

  - ### sweepFlagProperty

    public final BooleanProperty sweepFlagProperty()
    The sweep flag
    Default value:
      false
    See Also:
      - `isSweepFlag()`
      - `setSweepFlag(boolean)`

  - ### setX

    public final void setX(double value)
    Sets the value of the property x.
    Property description:
      The x coordinate to arc to.
    Default value:
      0.0

  - ### getX

    public final double getX()
    Gets the value of the property x.
    Property description:
      The x coordinate to arc to.
    Default value:
      0.0

  - ### xProperty

    public final DoubleProperty xProperty()
    The x coordinate to arc to.
    Default value:
      0.0
    See Also:
      - `getX()`
      - `setX(double)`

  - ### setY

    public final void setY(double value)
    Sets the value of the property y.
    Property description:
      The y coordinate to arc to.
    Default value:
      0.0

  - ### getY

    public final double getY()
    Gets the value of the property y.
    Property description:
      The y coordinate to arc to.
    Default value:
      0.0

  - ### yProperty

    public final DoubleProperty yProperty()
    The y coordinate to arc to.
    Default value:
      0.0
    See Also:
      - `getY()`
      - `setY(double)`

  - ### toString

    public String toString()
    Returns a string representation of this `ArcTo` object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this `ArcTo` object.